#!/usr/bin/python3

from charmhelpers.core import hookenv
from charmhelpers.core.services.base import ServiceManager
from charmhelpers.core.services import helpers

import actions


class MongoRelation(helpers.RelationContext):

    name = 'mongodb'
    interface = 'mongodb'


def manage():
    config = hookenv.config()
    manager = ServiceManager([
        {
            'service': 'result-enum-worker',
            'required_data': [config, MongoRelation()],
            'data_ready': [
                actions.basenode,
                actions.install_packages,
                actions.ensure_directories,
                actions.get_service_code_from_tarball,
                actions.install_python_packages,
                actions.get_config_file,
                actions.prepare_for_worker,
                helpers.render_template(
                    source='upstart.conf',
                    target='/etc/init/result-enum-worker.conf'),
                actions.log_start,
            ],
        },
    ])
    manager.manage()
